local dungeons = { 
	["Arcway"] = 467,
	["Azshara"] = 459,
	["Darkheart"] = 460,
	["Halls"] = 461,
	["Neltharion"] = 462,
	["Vault"] = 464,
	["Black"] = 463,
	["Maw"] = 465,
	["Court"] = 466,
	["Lower"] = 471,
	["Upper"] = 473,
	["Cath"] = 476,
	["Seat"] = 486,
}
 
local testingList = {

}

local keyStone = ""
local mLevel = 0
local dungeonID = 0
local usedEasyList = false

local f=CreateFrame("Button", "ELButton", GroupFinderFrame)
f:SetSize(46,46)
f:SetPoint("BOTTOMLEFT", GroupFinderFrame, 10, 10)
f:SetNormalTexture("Interface\\Icons\\INV_relics_hourglass")
f:SetHighlightTexture("Interface\\BUTTONS\\ButtonHilight-Square")
f:RegisterForClicks("LeftButtonUp")
f:Hide()

local t=CreateFrame("Button", nil, ItemRefTooltip)
t:SetSize(23,23)
t:SetPoint("BOTTOMRIGHT", ItemRefTooltip, -2, 2)
t:SetNormalTexture("Interface\\Icons\\INV_relics_hourglass")
t:SetHighlightTexture("Interface\\BUTTONS\\ButtonHilight-Square")
t:RegisterForClicks("LeftButtonUp")

local x = CreateFrame("frame")

x:SetScript("OnUpdate", function(self, elapsed)
	local name = ItemRefTooltip:GetItem()
	if name == "Mythic Keystone" then
		t:Show()
	else
		t:Hide()
	end
end)

--Goes through bag and finds keystone
function GetKey()
	for i = 0, NUM_BAG_SLOTS do
		for j = 1, GetContainerNumSlots(i) do
			local tempItem = GetContainerItemLink(i,j)
			if tempItem ~= nil and string.match(tempItem, "Keystone") then
				keyStone = tempItem
				f:Show()
			end
		end
	end
end

--Finds what roles are needed (3 DPS, 1 Healer, 1 Tank) and updates listing
function GetTitle()
	local roles = {
		HEALER = 1,
		TANK = 1,
		DAMAGER = 3,
	}
	local title = " Need"
	local playerRole = UnitGroupRolesAssigned("player")
	roles[playerRole] = roles[playerRole] - 1
	if IsInGroup() then
		local partyNum = GetNumGroupMembers()
		for i=1,partyNum-1 do
			local idk = UnitGroupRolesAssigned("party"..i)
			roles[idk] = roles[idk] - 1
		end
	end
	for k, v in pairs(roles) do
		if k == "HEALER" and v > 0 then
			title = title .. " Healer"
		end
		if k == "TANK" and v > 0 then
			title = title .. " Tank"
		end
		if k == "DAMAGER" and v > 0 then
			title = title .. " DPS"
		end
	end
	if(C_LFGList.UpdateListing(dungeonID, "+" .. mLevel .. title , 0, 0, "", "", false, false)) then end
end

--Parse Keystone link and list keystone
function ParseLink(item)
	local _, _, TmLevel = strsplit(":", item)
	usedEasyList = true
	for k, v in pairs(dungeons) do
		if 	string.match(item, k) then 
			if(C_LFGList.CreateListing(v, "+" .. TmLevel , 0, 0, "", "", false, false)) then
			dungeonID = v
			mLevel = TmLevel
			SetDungeonDifficultyID(23)
			LFGListUtil_OpenBestWindow(false);
			end
		end
	end
end

function ParseTooltip(item)
	local s1 = ItemRefTooltipTextLeft1:GetText()
	local s2 = ItemRefTooltipTextLeft2:GetText()
	local level = select(3, strsplit(" ", s2))
	usedEasyList = true;
	for k, v in pairs(dungeons) do
		if 	string.match(s1, k) then 
			if(C_LFGList.CreateListing(v, "+" .. level , 0, 0, "", "", false, false)) then
			dungeonID = v
			mLevel = level
			SetDungeonDifficultyID(23)
			LFGListUtil_OpenBestWindow(false);
			end
		end
	end
end


--Do click stuff
f:SetScript("PostClick", function(self, button, down)
	if button == "LeftButton" then ParseLink(keyStone) end
end)

t:SetScript("PostClick", function(self, button, down)
	local _,ttLink = ItemRefTooltip:GetItem()
	if button == "LeftButton" then ParseTooltip(ttLink) end 
end)

--Show keystone tooltip
f:SetScript("OnEnter", function(self) 
	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	GameTooltip:SetHyperlink(keyStone)
	GameTooltip:Show() 
end)

--Hide tooltip
f:SetScript("OnLeave", function(self) 
	GameTooltip:Hide() 
end)
	
f:RegisterEvent("LFG_LIST_ACTIVE_ENTRY_UPDATE")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("GROUP_ROSTER_UPDATE")

local g=CreateFrame("Button", nil, LFGListFrame.ApplicationViewer, "UIPanelButtonTemplate")
g:SetSize(100,22)
g:SetPoint("TOP", LFGListFrame.ApplicationViewer,  0, -85)
g:SetText("Update Listing")
g:SetFrameStrata("HIGH")
g:SetScript("PostClick", GetTitle)
g:Hide()

function EventHandler(self, event, ...)
	if event == "LFG_LIST_ACTIVE_ENTRY_UPDATE" then
		local isGroupListed = select(1, C_LFGList.GetActiveEntryInfo())
		if isGroupListed and usedEasyList then
			g:Show()
		end
		if not isGroupListed then
			g:Hide()
			usedEasyList = false
		end
	end

	if event == "PLAYER_ENTERING_WORLD" then
		GetKey()
	end
	
end

f:SetScript("OnEvent", EventHandler)